#include <windows.h>
#include <stdio.h>
#include <assert.h>

#define LOOPS 10000

static void test_CreateFileW(void)
{
    int i;

    for (i = 0; i < LOOPS; i++)
    {
        HANDLE hFile;

        hFile = CreateFileW(L"c:\\windows\\win.ini", GENERIC_READ,
                            FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, 0);
        assert(hFile != INVALID_HANDLE_VALUE);
        CloseHandle(hFile);
    }
}

static void test_FindFirstFileW(void)
{
    int i;

    for (i = 0; i < LOOPS; i++)
    {
        WIN32_FIND_DATAW fd;
        HANDLE hFind;

        hFind = FindFirstFileW(L"c:\\windows\\win.ini", &fd);
        assert(hFind != INVALID_HANDLE_VALUE);
        FindClose(hFind);
    }
}

int main(void)
{
    LARGE_INTEGER Timer;

    _asm {
        rdtsc
        mov Timer.LowPart, eax
        mov Timer.HighPart, edx
    }

    test_CreateFileW();
//    test_FindFirstFileW();

    _asm {
        rdtsc
        sub eax, Timer.LowPart
        sbb edx, Timer.HighPart
        mov Timer.LowPart, eax
        mov Timer.HighPart, edx
    }

    printf("time elapsed %ld ms\n", (long)Timer.QuadPart/1000000);

    return 0;
}
